Index: trunk/abdev/BasicCompiler64/Compile_Var.cpp
===================================================================
--- trunk/abdev/BasicCompiler64/Compile_Var.cpp	(revision 224)
+++ trunk/abdev/BasicCompiler64/Compile_Var.cpp	(revision 226)
@@ -54,5 +54,5 @@
 		if(typeSize>=2){
 			//imul reg,i2
-			op_imul_RV(sizeof(_int64),reg,typeSize);
+			compiler.codeGenerator.op_imul_RV(sizeof(_int64),reg,typeSize);
 		}
 	}
@@ -72,10 +72,10 @@
 
 	//add r11,reg
-	op_add64_reg(REG_R11,reg);
+	compiler.codeGenerator.op_add64_reg(REG_R11,reg);
 }
 void SetRelativeOffset( RELATIVE_VAR &relativeVar ){
 	if(relativeVar.dwKind==VAR_DIRECTMEM){
 		//mov r11,qword ptr[r11]
-		op_mov_RM(sizeof(_int64),REG_R11,REG_R11,0,MOD_BASE);
+		compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_R11,0,MOD_BASE);
 	}
 	else{
@@ -85,5 +85,5 @@
 
 		//mov r11,qword ptr[r12]
-		op_mov_RM(sizeof(_int64),REG_R11,REG_R12,0,MOD_BASE);
+		compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_R12,0,MOD_BASE);
 	}
 }
@@ -139,5 +139,5 @@
 
 	//xor r12,r12
-	op_zero_reg(REG_R12);
+	compiler.codeGenerator.op_zero_reg(REG_R12);
 
 	for(i=i3-1;i>=0;i--){
@@ -173,8 +173,8 @@
 
 		//imul reg,i4
-		op_imul_RV(sizeof(_int64),reg,i4);
+		compiler.codeGenerator.op_imul_RV(sizeof(_int64),reg,i4);
 
 		//add r12,reg
-		op_add64_reg(REG_R12,reg);
+		compiler.codeGenerator.op_add64_reg(REG_R12,reg);
 
 		HeapDefaultFree(pParm[i]);
@@ -352,5 +352,5 @@
 
 				//mov r11,qword ptr[r11]
-				op_mov_RM(sizeof(_int64),REG_R11,REG_R11,0,MOD_BASE);
+				compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_R11,0,MOD_BASE);
 			}
 			else{
@@ -652,5 +652,5 @@
 		//xor r11,r11（r11を0に初期化する）
 		//※r11は変数ベースアドレスからの相対オフセットを示す
-		op_zero_reg(REG_R11);
+		compiler.codeGenerator.op_zero_reg(REG_R11);
 
 		pRelativeVar->bOffsetOffset=1;
@@ -701,5 +701,5 @@
 
 				//mov r11,qword ptr[r12]
-				op_mov_RM(sizeof(_int64),REG_R11,REG_R12,0,MOD_BASE);
+				compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_R12,0,MOD_BASE);
 			}
 		}
@@ -721,5 +721,5 @@
 
 				//mov r11,qword ptr[r12]
-				op_mov_RM(sizeof(_int64),REG_R11,REG_R12,0,MOD_BASE);
+				compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_R12,0,MOD_BASE);
 			}
 			else{
@@ -872,5 +872,5 @@
 
 			//mov rax,DataPos
-			op_mov_RV(sizeof(_int64),REG_RAX,i2);
+			compiler.codeGenerator.op_mov_RV(sizeof(_int64),REG_RAX,i2);
 			obp-=sizeof(long);
 			pobj_DataTableSchedule->add();
@@ -878,5 +878,5 @@
 
 			//mov qword ptr[offset],rax
-			op_mov_MR(sizeof(_int64),REG_RAX,0,offset,MOD_DISP32);
+			compiler.codeGenerator.op_mov_MR(sizeof(_int64),REG_RAX,0,offset,MOD_DISP32);
 			obp-=sizeof(long);
 			pobj_GlobalVarSchedule->add();
@@ -1002,8 +1002,8 @@
 
 		//mov rax,i64data
-		op_mov64_ToReg(REG_RAX,i64data);
+		compiler.codeGenerator.op_mov64_ToReg(REG_RAX,i64data);
 
 		//mov qword ptr[rsp+offset],rax
-		op_mov_MR(sizeof(_int64),REG_RAX,REG_RSP,offset,MOD_BASE_DISP32);
+		compiler.codeGenerator.op_mov_MR(sizeof(_int64),REG_RAX,REG_RSP,offset,MOD_BASE_DISP32);
 		obp-=sizeof(long);
 		AddLocalVarAddrSchedule();
@@ -1015,5 +1015,5 @@
 
 		//mov dword ptr[rsp+offset],value
-		op_mov_MV(sizeof(long),REG_RSP,offset,USE_OFFSET,*(int *)&flt);
+		compiler.codeGenerator.op_mov_MV(sizeof(long),REG_RSP,offset,USE_OFFSET,*(int *)&flt);
 		obp-=sizeof(long)+sizeof(long);
 		AddLocalVarAddrSchedule();
@@ -1030,5 +1030,5 @@
 
 			//mov rax,i2
-			op_mov_RV(sizeof(_int64),REG_RAX,i2);
+			compiler.codeGenerator.op_mov_RV(sizeof(_int64),REG_RAX,i2);
 			obp-=sizeof(long);
 			pobj_DataTableSchedule->add();
@@ -1036,5 +1036,5 @@
 
 			//mov qword ptr[rsp+offset],rax
-			op_mov_MR(sizeof(_int64),REG_RAX,REG_RSP,offset,MOD_BASE_DISP32);
+			compiler.codeGenerator.op_mov_MR(sizeof(_int64),REG_RAX,REG_RSP,offset,MOD_BASE_DISP32);
 			obp-=sizeof(long);
 			AddLocalVarAddrSchedule();
@@ -1044,8 +1044,8 @@
 			if(i64data&0xFFFFFFFF00000000){
 				//mov rax,i64data
-				op_mov64_ToReg(REG_RAX,i64data);
+				compiler.codeGenerator.op_mov64_ToReg(REG_RAX,i64data);
 
 				//mov qword ptr[rsp+offset],rax
-				op_mov_MR(sizeof(_int64),REG_RAX,REG_RSP,offset,MOD_BASE_DISP32);
+				compiler.codeGenerator.op_mov_MR(sizeof(_int64),REG_RAX,REG_RSP,offset,MOD_BASE_DISP32);
 				obp-=sizeof(long);
 				AddLocalVarAddrSchedule();
@@ -1054,5 +1054,5 @@
 			else{
 				//mov qword ptr[rsp+offset],value
-				op_mov_MV(sizeof(_int64),REG_RSP,offset,USE_OFFSET,(int)i64data);
+				compiler.codeGenerator.op_mov_MV(sizeof(_int64),REG_RSP,offset,USE_OFFSET,(int)i64data);
 				obp-=sizeof(long)+sizeof(long);
 				AddLocalVarAddrSchedule();
@@ -1063,5 +1063,5 @@
 	else if( type.IsDWord() || type.IsLong() ){
 		//mov dword ptr[rsp+offset],value
-		op_mov_MV(sizeof(long),REG_RSP,offset,USE_OFFSET,(int)i64data);
+		compiler.codeGenerator.op_mov_MV(sizeof(long),REG_RSP,offset,USE_OFFSET,(int)i64data);
 		obp-=sizeof(long)+sizeof(long);
 		AddLocalVarAddrSchedule();
@@ -1070,5 +1070,5 @@
 	else if( type.IsWord() || type.IsInteger() ){
 		//mov word ptr[rsp+offset],value
-		op_mov_MV(sizeof(short),REG_RSP,offset,USE_OFFSET,(int)i64data);
+		compiler.codeGenerator.op_mov_MV(sizeof(short),REG_RSP,offset,USE_OFFSET,(int)i64data);
 		obp-=sizeof(long)+sizeof(short);
 		AddLocalVarAddrSchedule();
@@ -1077,5 +1077,5 @@
 	else if( type.IsSByte() || type.IsByte() || type.IsBoolean() ){
 		//mov byte ptr[rsp+offset],value
-		op_mov_MV(sizeof(char),REG_RSP,offset,USE_OFFSET,(int)i64data);
+		compiler.codeGenerator.op_mov_MV(sizeof(char),REG_RSP,offset,USE_OFFSET,(int)i64data);
 		obp-=sizeof(long)+sizeof(char);
 		AddLocalVarAddrSchedule();
@@ -1182,14 +1182,14 @@
 
 			//mov r8, 0
-			op_zero_reg( REG_R8 );
+			compiler.codeGenerator.op_zero_reg( REG_R8 );
 
 			//mov rdx, VarSize
-			op_mov_RV( sizeof(_int64), REG_RDX, pVar->GetMemorySize() );
+			compiler.codeGenerator.op_mov_RV( sizeof(_int64), REG_RDX, pVar->GetMemorySize() );
 
 			//mov rcx, rsp
-			op_mov_RR( REG_RCX, REG_RSP );
+			compiler.codeGenerator.op_mov_RR( REG_RCX, REG_RSP );
 
 			//add rcx, offset
-			op_add_RV( REG_RCX, -pVar->GetOffsetAddress() );
+			compiler.codeGenerator.op_add_RV( REG_RCX, -pVar->GetOffsetAddress() );
 			obp-=sizeof(long);
 			AddLocalVarAddrSchedule();
@@ -1199,5 +1199,5 @@
 			DllProc *pDllProc;
 			pDllProc=GetDeclareHash("FillMemory");
-			op_call( pDllProc );
+			compiler.codeGenerator.op_call( pDllProc );
 		}
 	}
@@ -1240,9 +1240,9 @@
 
 			//mov reg,r11
-			op_mov_RR(reg,REG_R11);
+			compiler.codeGenerator.op_mov_RR(reg,REG_R11);
 		}
 		else{
 			//mov reg,offset
-			op_mov64_ToReg(reg,(int)pRelativeVar->offset);
+			compiler.codeGenerator.op_mov64_ToReg(reg,(long)pRelativeVar->offset);
 			obp-=sizeof(long);
 			pobj_GlobalVarSchedule->add();
@@ -1253,5 +1253,5 @@
 		if(pRelativeVar->bOffsetOffset){
 			//add r11,qword ptr[offset]
-			op_add_RM( sizeof(_int64), REG_R11, REG_NON, (int)pRelativeVar->offset, MOD_DISP32 );
+			compiler.codeGenerator.op_add_RM( sizeof(_int64), REG_R11, REG_NON, (int)pRelativeVar->offset, MOD_DISP32 );
 			obp-=sizeof(long);
 			pobj_GlobalVarSchedule->add();
@@ -1260,5 +1260,5 @@
 		else{
 			//mov r11,qword ptr[offset]
-			op_mov_RM(sizeof(_int64),REG_R11,REG_NON,(int)pRelativeVar->offset,MOD_DISP32);
+			compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_NON,(int)pRelativeVar->offset,MOD_DISP32);
 			obp-=sizeof(long);
 			pobj_GlobalVarSchedule->add();
@@ -1279,15 +1279,15 @@
 
 			//add r11,rsp
-			op_add64_reg(REG_R11,REG_RSP);
+			compiler.codeGenerator.op_add64_reg(REG_R11,REG_RSP);
 
 			//mov reg,r11
-			op_mov_RR(reg,REG_R11);
+			compiler.codeGenerator.op_mov_RR(reg,REG_R11);
 		}
 		else{
 			//mov reg,rsp
-			op_mov_RR(reg,REG_RSP);
+			compiler.codeGenerator.op_mov_RR(reg,REG_RSP);
 
 			//add reg,offset
-			op_add_RV(reg,(int)pRelativeVar->offset);
+			compiler.codeGenerator.op_add_RV(reg,(int)pRelativeVar->offset);
 			obp-=sizeof(long);
 			AddLocalVarAddrSchedule();
@@ -1308,5 +1308,5 @@
 		else{
 			//mov r11,qword ptr[rsp+offset]
-			op_mov_RM(sizeof(_int64),REG_R11,REG_RSP,(int)pRelativeVar->offset,MOD_BASE_DISP32);
+			compiler.codeGenerator.op_mov_RM(sizeof(_int64),REG_R11,REG_RSP,(int)pRelativeVar->offset,MOD_BASE_DISP32);
 			obp-=sizeof(long);
 			AddLocalVarAddrSchedule();
@@ -1319,5 +1319,5 @@
 directmem:
 		//mov reg,r11
-		op_mov_RR(reg,REG_R11);
+		compiler.codeGenerator.op_mov_RR(reg,REG_R11);
 	}
 }
@@ -1337,9 +1337,9 @@
 			// 変数領域に要するLONG_PTR単位の個数を引き渡す
 			//mov r8,count
-			op_mov_RV(sizeof(_int64), REG_R8,pVar->GetMemorySize()/PTR_SIZE);
+			compiler.codeGenerator.op_mov_RV(sizeof(_int64), REG_R8,pVar->GetMemorySize()/PTR_SIZE);
 
 			// ルートポインタを引き渡す
 			//mov rdx,offset
-			op_mov_RV(sizeof(_int64), REG_RDX,(int)pVar->GetOffsetAddress());
+			compiler.codeGenerator.op_mov_RV(sizeof(_int64), REG_RDX,(int)pVar->GetOffsetAddress());
 			obp-=sizeof(long);
 			pobj_GlobalVarSchedule->add();
@@ -1350,5 +1350,5 @@
 
 			// call AddGlobalRootPtr
-			op_call( pUserProc_AddGlobalRootPtr );
+			compiler.codeGenerator.op_call( pUserProc_AddGlobalRootPtr );
 
 			ReallocNativeCodeBuffer();