Index: trunk/abdev/BasicCompiler_Common/src/CommonCodeGenerator.cpp
===================================================================
--- trunk/abdev/BasicCompiler_Common/src/CommonCodeGenerator.cpp	(revision 241)
+++ trunk/abdev/BasicCompiler_Common/src/CommonCodeGenerator.cpp	(revision 245)
@@ -53,5 +53,5 @@
 			}
 
-			pertialSchedules.erase( it );
+			it = pertialSchedules.erase( it );
 			delete pPertialSchedule;
 
@@ -69,5 +69,5 @@
 	}
 }
-CodeGenerator::PertialSchedule *CodeGenerator::__jmp_op_format( char opcode, long offset, int op_size, bool isPertialSchedule, bool isSelfOpcodeOffset )
+const CodeGenerator::PertialSchedule *CodeGenerator::__jmp_op_format( char opcode, long offset, int op_size, bool isPertialSchedule, bool isSelfOpcodeOffset )
 {
 	long beginCodePos = pNativeCode->GetSize();
@@ -111,5 +111,5 @@
 	}
 
-	PertialSchedule *pPertialSchedule = NULL;
+	const PertialSchedule *pPertialSchedule = NULL;
 	if( isPertialSchedule )
 	{
@@ -143,45 +143,45 @@
 	return pPertialSchedule;
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jle( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jle( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x0E, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jbe( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jbe( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x06, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jge( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jge( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x0D, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jae( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jae( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x03, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jl( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jl( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x0C, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jb( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jb( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x02, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jg( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jg( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x0F, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_ja( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_ja( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x07, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jne( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jne( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x05, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_je( long offset, int op_size, bool isPertialSchedule )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_je( long offset, int op_size, bool isPertialSchedule )
 {
 	return __jmp_op_format( (char)0x04, offset, op_size, isPertialSchedule );
 }
-CodeGenerator::PertialSchedule *CodeGenerator::op_jmp( long offset, int op_size, bool isPertialSchedule, bool isSelfOpcodeOffset )
+const CodeGenerator::PertialSchedule *CodeGenerator::op_jmp( long offset, int op_size, bool isPertialSchedule, bool isSelfOpcodeOffset )
 {
 	return __jmp_op_format( (char)0xEB, offset, op_size, isPertialSchedule, isSelfOpcodeOffset );